"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
require("./index.css");
var DynamicList = function (props) {
    var childrenWithProps = react_1.default.Children.map(props.children, function (child) {
        if (react_1.default.isValidElement(child)) {
            return react_1.default.cloneElement(child, __assign({}, props));
        }
        return child;
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: 'dynamic_list_container' }, childrenWithProps)));
};
var Header = function (props) {
    var _a = props.data, data = _a === void 0 ? [] : _a;
    return (react_1.default.createElement("div", { style: props.style, className: 'dynamic_list_container__header' },
        props.heading && (react_1.default.createElement("div", null, props.heading)),
        props.resultCountEnabled && (react_1.default.createElement(react_1.default.Fragment, null, data.length > 0 ? (react_1.default.createElement("div", null, "".concat(data.length, " result found"))) : (react_1.default.createElement("div", null, "No results found"))))));
};
var Body = function (props) {
    var _a = props.data, data = _a === void 0 ? [] : _a, cardType = props.cardType;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: 'dynamic_list_container__body' },
            react_1.default.createElement(react_1.default.Fragment, null, data.map(function (dataElement, index) {
                var Component = cardType;
                return react_1.default.createElement(Component, __assign({ key: "".concat(cardType, "-").concat(index) }, dataElement));
            })))));
};
DynamicList.Header = Header;
DynamicList.Body = Body;
exports.default = DynamicList;
