var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import './index.css';
var DynamicList = function (props) {
    var childrenWithProps = React.Children.map(props.children, function (child) {
        if (React.isValidElement(child)) {
            return React.cloneElement(child, __assign({}, props));
        }
        return child;
    });
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: 'dynamic_list_container' }, childrenWithProps)));
};
var Header = function (props) {
    var _a = props.data, data = _a === void 0 ? [] : _a;
    return (React.createElement("div", { style: props.style, className: 'dynamic_list_container__header' },
        props.heading && (React.createElement("div", null, props.heading)),
        props.resultCountEnabled && (React.createElement(React.Fragment, null, data.length > 0 ? (React.createElement("div", null, "".concat(data.length, " result found"))) : (React.createElement("div", null, "No results found"))))));
};
var Body = function (props) {
    var _a = props.data, data = _a === void 0 ? [] : _a, cardType = props.cardType;
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: 'dynamic_list_container__body' },
            React.createElement(React.Fragment, null, data.map(function (dataElement, index) {
                var Component = cardType;
                return React.createElement(Component, __assign({ key: "".concat(cardType, "-").concat(index) }, dataElement));
            })))));
};
DynamicList.Header = Header;
DynamicList.Body = Body;
export default DynamicList;
